%!octave 
%
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: data_load_txt.m,v 1.1 2016/03/18 09:46:16 mechanoid Exp $


% каждый класс разделяется в заданной пропорции на три набора
% [ учебный | контрольный | тестовый ]
% номера точек выбираются случайным образом
function [ L C T ]=data_load_txt(),
   
   [ cl r ] = data_path_points(); % загружаем образцы

   X=[];Y=[]; % полная матрица образцов с выходами
   ncl=length(cl) ; % количество классов
   for i=1:ncl, 
      sc=size(cl{i},1); % количество образцов в классе
	  X=[ X (cl{i})' ];
	  yi=zeros(ncl,sc);
	  yi(i,:)=1;
	  Y=[ Y yi ];
	  %Y=[ Y zeros(i-1, sc) ones(1,sc) zeros(ncl-i, sc) ];

   endfor

   X=lin_corr(X,1.0);
   
   save("-text","result/x.txt", "X" ) ;
   save("-text","result/y.txt", "Y" ) ;

   se=size(X,2); % общее количество образцов 
   rs=randperm(se); % случайная последовательность номеров образцов

   sl=round(se*r(1)); % количество учебных примеров 
   idx=rs(1:sl); % случайные номера учебных примеров из общего набора
   L={ X(:,idx), Y(:,idx) };

   sc=round(se*r(2)); % количество контрольных примеров
   idx=rs([1:sc]+sl);% случайные номера контрольных примеров из общего набора
   C={ X(:,idx), Y(:,idx) };

   st=round(se*(1.0 -sum(r))) ; % количество тестовых примеров
   idx=rs([1:st]+(sl+sc-1));% случайные номера тестовых примеров из общего набора
   T={ X(:,idx), Y(:,idx) };

   save("-text","result/l.txt", "L" ) ;
   save("-text","result/c.txt", "C" ) ;
   save("-text","result/t.txt", "T" ) ;

   plot_txt(L,"xl",-1) ;
   plot_txt(C,"xc",-1) ;
   plot_txt(T,"xt",-1) ;

   printf("[i] %i - %i / %i / %i \n",se, size(L{2},2),size(C{2},2),size(T{2},2) );

endfunction
