%!octave 
%
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_txt.m,v 1.1 2016/03/18 09:46:16 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% рисует 2D набор данных X с метками Y
% результат записывается в файл {file}.gif
% j - значение ошибки на тестах для заголовка картинки
% (для отображения учебных наборов j=-1)
%
function plot_txt(D,file,j),
   pix_size="-S420,420"; % размер картинки
   pix_font_size=8; % размер шрифта
   pix_format="gif"; % тип файла

   X=D{1};y=D{2};
   szX=size(X,2) ; % количество точек

   xm=ceil(max(max(X))) ; ax=[ 0 xm 0 xm ] ; % размер области

   % инициализируем картинку
   clf; hold on; axis(ax); grid on; set(gca,'fontsize',pix_font_size); 
   
   plot_points(X,y); % рисуем точки

   % имя файла
   file=sprintf("result/%s.%s",file,pix_format);
   fm=sprintf("-d%s",pix_format);

   % заголовок на картинке
   if(j>0), % если картинка с результатом 
      % то печатаем в заголовке значение ошибки теста
	  title(sprintf('results - points: %i, error: %f',szX,j)) ;
   else
      % иначе печатаем в заголовке только количество точек
	  title(sprintf('points: %i',szX)) ;
   endif
   
   print(file,fm,pix_size) ; % записываем в файл

endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% рисует 2D набор данных X с метками y
function plot_points(X,Y),
   %sz=length(unique(sort(y))) ; % количество классов
   sz=size(Y,1) ; % количество классов
   
   if sz<7, % цвета классов RGB
	  clr=[ 
		0 0 1 ;
		1 0 0 ;
		0 1 0 ;
		1 0 1 ;       
		1 1 0 ;
		0 1 1 
	  ] ;
   else
	  clr=jet(sz) ;
   endif

   [m im]=max(Y) ;

   for i=1:sz,
	  ix=find(im==i) ; % номера точек класса номер i
	  if length(ix)>0 , 
		 plot( X(1,ix), X(2,ix), ".", "color", clr(i,:) ) ; 
	  endif
   endfor

endfunction

