%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: trn_stop_condition.m,v 1.1 2016/04/21 18:33:59 mechanoid Exp mechanoid $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% условия остановки обучения
%
% min_err - порог допустимой ошибки обучения
% er - итория изменения ошибки
% er_win_size - размер окна контроля за ошибкой
%
function retval= trn_stop_condition(er_hist,min_err,er_win_size),
   ERR_MIN_DIFF=1e-5; % порог минимального отклонения ошибки обучения 

   er = er_hist(end-er_win_size:end);

   if isnan(er(end)), 
	  printf("\n[e] ошибка вычислений           \n") ;
	  exit -1;	  
	  return;
   endif

   if er(end)<min_err , 
	  printf("\n[i] достигнут порог допустимой ошибки обучения           \n") ;
	  retval=1;
	  return;
   endif


   if m_inc(er), 
	  printf("\n[w] ошибка обучения монотонно возрастает           \n") ;
	  retval=1;
	  return;
   endif

   
   md=max(abs(mean(er)-er)) ; % максимальное отклонение ошибки от среднего значения в окне контроля
   if md < ERR_MIN_DIFF,
	  printf("\n[w] достигнут порог минимального отклонения ошибки обучения          \n") ;
	  retval=1;
	  return;
   endif

   retval=0;

endfunction 

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=m_inc(x),
   retval=prod((x>shift(x,1))(2:end)) ;
endfunction
