%!octave 
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_activate_drvt.m,v 1.3 2016/04/12 13:19:18 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% производная функции активации 
function retval=mlp_activate_drvt(x,ta),
   switch(ta)
	  case "tanh" 
		 b=1.0; retval = b ./ (cosh(b*x).^2) ;

	  case "expsig"
		 b=2.0; a=10.0; 
		 retval=b*a*exp(-x.*a)./((1+exp(-x.*a)).^2);

	  case "exprob"
		 b=1.0; a=1.0; 
		 retval=b*a*exp(-x.*a)./((1+exp(-x.*a)).^2);
		 %retval=retval.*mlp_activate(x,ta);

	  case "lrelu" % Leaky ReLU
	     %a=0.09; retval=double(x>a); 
		 retval=exp(x)./(exp(x)+1.0);

	  case "relu"
		 retval=double(x>0);

	  case "softmax"
		 retval=softmax_drv(x) ;	

	  otherwise 
		 printf("\n[e] не изестная функция активации %s\n",ta);
		 exit -1;

   endswitch
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval=softmax_drv(x),
   sz_x  = size(x,1) ; % размер слоя x
   ex_numb = size(x,2) ; % количество примеров

   x3 = permute(reshape(x',[1 ex_numb sz_x]) , [ 3 1 2] ) ; % разбираем матрицу на столбцы
   x3t = reshape(x,[1 sz_x ex_numb]) ; % разбираем матрицу на столбцы и транспонируем их в строки
   m=eye([sz_x,sz_x]).*ones([1,1,ex_numb]) ;
   d3=x3.*(m.-x3t) ; % набор якобианов для всех примеров
   % d = reshape(permute(d3,[1 3 2]),[sz_x*ex_numb,sz_x]); % собираем якобианы в одну матрицу

   retval=d3;

endfunction

%x=rand([3,4])
%x=reshape(12:-1:1,[3,4])
%x=reshape(1:12,[3,4])
%softmax_drv1(x);

% % - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% function retval=softmax_drv(x),
%    n=size(x,1); % количество примеров
%    m=size(x,2); % размер выхода (количество нейронов в слое)
%    xr=reshape(x',[1,m,n ]) ;
%    for i=1:n, xt(:,:,i)=xr(:,:,i)'; endfor
%    d=eye([m m]).*ones([m m n]) ;
%    r=xt.*(d.-xr) ;
%    rs=sum(r,1);
%    retval=reshape( rs , [m n 1] )' ;
% endfunction

