%!octave 
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_loss_drvt.m,v 1.1 2016/03/19 19:02:54 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% значения производной функция ошибки (потери) сети на последнем слое
%
function retval = mlp_loss_drvt(l,y,cfg),
   ltp=2; % номер ячейки cfg с типом ф-ции активации

   o = mlp_activate( l, cfg{end}{ltp} ) ; % выход последнего слоя

   switch( cfg{end}{ltp} ),

	  case "softmax" % для выхода softmax используем среднюю крос-энтропию
		retval = ( o - y ) ;

	  % case "tanh" case "expsig" case "relu"
	  otherwise % для остальных типов выхода используем среднюю квадратическую ошибку
		d = mlp_activate_drvt( l, cfg{end}{ltp} ) ; % значение производной ф-ции активации 
		retval = ( o - y ).*d; 

   endswitch

endfunction

