%!octave 
%
%
%       OS : GNU/Linux 4.2.5-1-ARCH 
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: mlp_weight_pack.m,v 1.1 2016/03/19 19:02:54 mechanoid Exp $



% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% пакуем вектор весов в матрицы
%
function retval = mlp_weight_pack(W,cfg),
   lsz = 1 ; % номер ячейки cfg с размером слоя
   layers_numb = length(cfg) ; % количество слоёв сети, включая вход

   p=1; R={};
   for i=1:layers_numb-1,
	  sw = [ cfg{i+1}{lsz}, cfg{i}{lsz} ] ; % размер матрицы весов
	  swp=prod(sw);
	  R{i}{1} = reshape( W(p:p-1+swp), sw ); % упаковываем матрицу весов
	  p += swp ;
   endfor

    for i=1:layers_numb-1,
	  sb = cfg{i+1}{lsz} ; % размер вектора сдвигов
	  R{i}{2} = W( p:p-1+sb); % упаковываем вектор сдвигов
	  p += sb ;
   endfor

   retval = R ;

endfunction

